#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct el {
	struct el *l,*d,*r;
	int boja;
	char *ime;
	char *tip;
	char *kat;
};

#define novi(x) x=(struct el *)malloc(sizeof(struct el));

enum{CRNA,CRVENA};

void lrot(struct el **p){
	struct el *pom, *pom1;
	//printf("rot d");
	pom=*p;
	pom1=pom->d;
	pom->d=pom1->l;
	if(pom1->l) pom1->l->r=pom;
	pom1->r=pom->r;
	if(pom->r){
		if(pom==pom->r->l) pom->r->l=pom1;
		else pom->r->d=pom1;
	}
	pom1->l=pom;
	pom->r=pom1;
	*p=pom1;
}

void drot(struct el **p){
	struct el *pom, *pom1;
	//printf("rot d");
	pom=*p;
	pom1=pom->l;
	pom->l=pom1->d;
	if(pom1->d) pom1->d->r=pom;
	pom1->r=pom->r;
	if(pom->r){
		if(pom==pom->r->d) pom->r->d=pom1;
		else pom->r->l=pom1;
	}
	pom1->d=pom;
	pom->r=pom1;
	*p=pom1;
}


void bojefix(struct el **p, struct el *z){
	struct el *t,*y;
	
	//printf("udje bojefix\n");
	while((z->r)&&(z->r->boja==CRVENA)){
		if(z->r==z->r->r->l){
			y=z->r->r->d;
			if((y)&&(y->boja==CRVENA)){
				z->r->boja= CRNA;
				y->boja=CRNA;
				z->r->r->boja=CRVENA;
				z=z->r->r;
			}
			else{
				if(z==z->r->d){
					z=z->r;
					lrot(&z);
					if(!z->r) *p=z;
					z=z->l;
				}
				z->r->boja=CRNA;
				z->r->r->boja=CRVENA;
				t=z->r->r;
				drot(&t);
				if(!t->r) *p=t;
			}
		}
		else {
			y=y->r->r->l;
			if((y)&&(y->boja==CRVENA)){
				z->r->boja=CRNA;
				y->boja= CRNA;
				z->r->r->boja=CRVENA;
				z=z->r->r;
			}
			else{
				if(z==z->r->l){
					z=z->r;
					drot(&z);
					if(!z->r) *p=z;
					z=z->d;
				}
				z->r->boja=CRNA;
				z->r->r->boja=CRVENA;
				t=z->r->r;
				lrot(&t);
				if(!t->r) *p=t;
			}
		}
	}
	(*p)->boja=CRNA;
}

void dodaj(struct el **p, struct el *z){
	struct el *pom, *pom1;
	int vr,vr2;
	
	if(strcmp(z->tip,"rad")==0){
		if(strcmp(z->kat,"M21")==0) vr=1;
		else vr=3;}
	else
		if(strcmp(z->tip,"monografija")==0) vr=2;
		else vr=4;
		
	//printf("vr je: %d\n",vr);

	pom=(*p);
	pom1=NULL;
	while(pom!=NULL){
		pom1=pom;
		if(strcmp(pom->tip,"rad")==0){
			if(strcmp(pom->kat,"M21")==0) vr2=1;
			else vr2=3;}
		else{
			if(strcmp(pom->tip,"monografija")==0) vr2=2;
			else vr2=4;}
		//printf("vr2 je: %d\n",vr2);
		if(vr2<vr) {
			//printf("ide levo\n"); 
			pom=pom->l;}
		else {
			//printf("ide desno\n"); 
			pom=pom->d;}

	}
	z->r=pom1;
	if(pom1==NULL) {
		(*p)=z; 
		//printf("udje glava\n"); 
		}
	else{
		//printf("udje dalje\n");
		//printf("ime gl je: %s\n",pom1->ime);
		if(vr2<vr) pom1->l=z;
		else pom1->d=z;
	}
	bojefix(p,z);
}

struct el *form(){
	struct el *p=NULL, *z;
	char ime1[30], tip1[30], kat1[30];
	int i,n;
	
	printf("Unesi br naucnika: ");
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++){
		printf("Unesi ime: ");
		gets(ime1);
		printf("Unesi tip: ");
		gets(tip1);
		if(strcmp(tip1,"rad")==0) {
			printf("Unesi kategoriju: ");
			gets(kat1);
		}
		novi(z);
		z->ime=(char *)malloc(strlen(ime1)+1);
		strcpy(z->ime,ime1);
		z->tip=(char *)malloc(strlen(tip1)+1);
		strcpy(z->tip,tip1);
		if(strcmp(tip1,"rad")==0){
			z->kat=(char *)malloc(strlen(kat1)+1);
			strcpy(z->kat,kat1);
		}
		z->boja=CRVENA;
		z->r=z->l=z->d=NULL;
		dodaj(&p,z);
	}
	return p;
}

void ispis(struct el *p){
	if(p!=NULL){
		ispis(p->l);
		printf("%s\t %s\t",p->ime,p->tip);
		if(strcmp(p->tip,"rad")==0){
			if(strcmp(p->kat,"M21")==0) printf("M21\t");
			else printf("M22\t"); }
		if(p->boja==CRVENA) printf("CRVENA");
		else printf("CRNA");
		ispis(p->d);
	}
	printf("\n");
}

void brisi(struct el **p, struct el *q){
	struct el *pom;
	
	if(q!=NULL)
		if(strcmp(q->tip,"rad")==0){
			novi(pom);
			pom->ime=(char *)malloc(strlen(q->ime)+1);
			strcpy(pom->ime,q->ime);
			pom->tip=(char *)malloc(strlen(q->tip)+1);
			strcpy(pom->tip,q->tip);
			if(strcmp(q->tip,"rad")==0){
				pom->kat=(char *)malloc(strlen(q->kat)+1);
				strcpy(pom->kat,q->kat);
			}
			pom->r=pom->d=pom->l=NULL;
			pom->boja=CRVENA;
			dodaj(p,pom);
			brisi(p,q->l);
			brisi(p,q->d);
		}
		else{
			brisi(p,q->l);
			brisi(p,q->d);
		}
		else return;
}

int brojn(struct el *p){
	int static brr1=0;
	int static brr2=0;
	struct el *pom;
	
	pom=p;
	if(pom==NULL) {
		if(brr1>brr2) return 1;
		else return 2;
	}
	if(strcmp(pom->tip,"rad")==0 && strcmp(pom->kat,"M21")==0) brr1++;
	if(strcmp(pom->tip,"monografija")==0) brr2++;
	brojn(p->l);
	brojn(p->d);
}

main(){
	struct el *p=NULL;
	struct el *q;
	int vise;
	
	p=form();
	ispis(p);
	brisi(&q,p);
	ispis(q);
	vise=brojn(p);
	if(vise==2) printf("Vise ima naucnika sa monigrafiji");
	else printf("Vise ima naucnika sa M21");
}


