#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>

enum{CRVENA,CRNA};

struct drvo 
{
 char *ime;
 char *tiprada;
 char *kategorijarada;
 int boja;
 struct drvo *levi,*desni,*roditelj;
};

#define novi(x) x=(struct drvo *)malloc(n*sizeof(char))

void lrotacija(struct drvo **t)
{
 struct drvo *x,*y;
 x=*t;
 y=x->desni;
 x->desni=y->levi;
 if(y->levi)y->levi->roditelj=x;
 y->roditelj=x->roditelj;
 if(x->roditelj)
   if(x==x->roditelj->levi)x->roditelj->levi=y;
     else x->roditelj->desni=y;

y->levi=x;
x->roditelj=y;
*t=y;
}

void drotacija(struct drvo **t)
{
 struct drvo *x,*y;
 x=*t;
 y=x->levi;
 x->levi=y->desni;
 if(y->desni)y->desni->roditelj=x;
 y->roditelj=x->roditelj;
 if(x->roditelj)
   if(x==x->roditelj->levi)x->roditelj->levi=y;
     else x->roditelj->desni=y;

y->desni=x;
x->roditelj=y;
*t=y;
}

void bojefix(struct drvo **p,struct drvo *z)
{
 struct drvo *y,*t;
 while((z->roditelj)&&(z->roditelj->boja==CRVENA))
  {
   if(z->roditelj==z->roditelj->roditelj->levi)
    {
     y=z->roditelj->roditelj->desni;
     if((y)&&(y->boja==CRVENA))
       {
        y->boja=CRNA;
        z->roditelj->boja=CRNA;
        z->roditelj->roditelj->boja=CRVENA;
        z=z->roditelj->roditelj;
       }
      else
       {
        if(z==z->roditelj->desni)
         {
          z=z->roditelj;
          lrotacija(&z);
          if(!z->roditelj)*p=z;
          z=z->levi;
         }
        z->roditelj->roditelj->boja=CRVENA;
        z->roditelj->boja=CRNA;
        t=z->roditelj->roditelj;
        drotacija(&t);
        if(!t->roditelj) *p=t;
       }
    }
 else
    {
     y=z->roditelj->roditelj->levi;
     if((y)&&(y->boja==CRVENA))
       {
        y->boja=CRNA;
        z->roditelj->boja=CRNA;
        z->roditelj->roditelj->boja=CRVENA;
        z=z->roditelj->roditelj;
       }
      else
       {
        if(z==z->roditelj->levi)
         {
          z=z->roditelj;
          drotacija(&z);
          if(!z->roditelj)*p=z;
          z=z->desni;
         }
        z->roditelj->roditelj->boja=CRVENA;
        z->roditelj->boja=CRNA;
        t=z->roditelj->roditelj;
        lrotacija(&t);
        if(!t->roditelj) *p=t;
       }
    }
  }
(*p)->boja=CRNA;
} 

int tiprada(struct drvo *x)
{
 if(strcmp(x->tiprada,"nema")==0)return 0;
  if(strcmp(x->tiprada,"monografija")==0)return 2;
 if(strcmp(x->tiprada,"rad")==0)
   {
    if(strcmp(x->kategorijarada,"M22")==0)return 1;
    if(strcmp(x->kategorijarada,"M21")==0)return 3;
   }
return 0;
}

void dodaj(struct drvo **p,struct drvo *z)
{
 struct drvo *x,*y;
 y=NULL;
 x=*p;
 while(x)
  {
   y=x;
   //printf("tip rada %d   %d \n",tiprada(z),tiprada(x));
   if(tiprada(z)<tiprada(x))x=x->levi;
   else x=x->desni;
  }
z->roditelj=y;
if(!z->roditelj)*p=z;
 else
    {
    // printf("tip rada %d   %d \n",tiprada(z),tiprada(y));
     if(tiprada(z)<tiprada(y))y->levi=z; 
     else y->desni=z;
    }
bojefix(p,z);
}

struct drvo *form()
{
 struct drvo *koren,*temp;
 koren=NULL;
 int n;
 novi(temp);
 char s[30],s2[30],s3[30];
 printf("Unesite broj N\n");
 scanf("%d",&n);
 getchar();
 while(n)
 {
  novi(temp);
 
  printf("Unesite ime naucnika\n");
  gets(s);
  temp->ime=(char*)malloc((strlen(s))*2*sizeof(char));
  strcpy(temp->ime,s);
  printf("Uneli ste ime : %s\n",temp->ime);
  
  printf("Unesite tip rada.\n");
  gets(s2);
  temp->tiprada=(char*)malloc((strlen(s2)+1)*sizeof(char));
  strcpy(temp->tiprada,s2);
  if(strcmp(temp->tiprada,"rad")==0)
    {
       printf("Unesite kategoriju rada.\n");
       gets(s3);
       temp->kategorijarada=(char*)malloc((strlen(s3)+1)*sizeof(char));
       strcpy(temp->kategorijarada,s3);
    }
   temp->boja=CRVENA;
   temp->levi=temp->desni=NULL;
   dodaj(&koren,temp);
  n--;
 }
//printf("Ime korena je %s\n",koren->ime);
return koren;
}

void ispis(struct drvo *p)
{
 if(p!=NULL)
   {
    ispis(p->desni);
    printf("%s\t%s\t",p->ime,p->tiprada);
    if(strcmp(p->tiprada,"rad")==0)printf("%s\t",p->kategorijarada);
    if(p->boja==CRVENA)printf("\t(CRVENA)\n"); 
    else printf("\t(CRNA)\n");
    ispis(p->levi);
   }

}

void brisi(struct drvo **p,struct drvo *q)
{
 struct drvo *pom;
 if(q!=NULL)
  if(strcmp(q->tiprada,"nema")!=0)
  {
   pom=(struct drvo *)malloc(sizeof(struct drvo));

   pom->ime=(char*)malloc((strlen(q->ime)+1)*sizeof(char));
   strcpy(pom->ime,q->ime);
   
   pom->tiprada=(char*)malloc((strlen(q->tiprada)+1)*sizeof(char));
   strcpy(pom->ime,q->tiprada);

   if(strcmp(q->tiprada,"rad")==0)
   {
   pom->kategorijarada=(char*)malloc((strlen(q->kategorijarada)+1)*sizeof(char));
   strcpy(pom->kategorijarada,q->kategorijarada);
   //("%s kategorija \n",pom->kategorijarada);
   }
   
  pom->levi=pom->desni=pom->roditelj=NULL;
  dodaj(p,pom);
  brisi(p,q->levi);
  brisi(p,q->desni);
  }
else
  {
   brisi(p,q->levi);
   brisi(p,q->desni);
  }
else return;
}

int m(struct drvo *p)
{
 int m=0,mon=0;
 struct drvo *pom1,*pom2;
 pom1=p;
 while(pom1)
  {
   if((strcmp(p->tiprada,"rad")==0)&&(strcmp(p->kategorijarada,"M21")==0))
     m++;
   pom1=pom1->levi;
  } 
pom2=p->desni;
 while(pom2)
  {
   if((strcmp(pom2->tiprada,"rad")==0)&&(strcmp(pom2->kategorijarada,"M21")==0))
    m++;
   pom2=pom2->desni;
  }
return m;
}


int mon(struct drvo *p)
{
 int m=0,mon=0;
 struct drvo *pom1,*pom2;
 pom1=p;
 while(pom1)
  {
   if((strcmp(p->tiprada,"monografija")==0))
    m++;
   pom1=pom1->levi;
  } 
pom2=p->desni;
 while(pom2)
  {
   if((strcmp(pom2->tiprada,"monografija")==0))
    m++;
   pom2=pom2->desni;
  }
return m;
}

main()
{
 struct drvo *p,*q;
 p=NULL;
 q=NULL;
 p=form();
 ispis(p);

  printf("Monografija ima %d, a naucnih radova u kategoriji M21 ima %d\n",mon(p),m(p));
 if(mon(p)>m(p))printf("Vise ima monografija\n");
   else if(mon(p)<m(p)) printf("Vise ima naucnih radova\n");
         else printf("Ima ih isto\n");
  printf("------------\nPosle brisanja:\n");
 brisi(&q,p);
 ispis(q);

}
