#include<stdio.h>
#include<stdlib.h>
#include<string.h>


typedef struct takmicenje{
	char * ekipa;
	char * igra;
	int broj;
	struct takmicenje* next;
}takmicenje;

#define novi(x) x=(takmicenje*)malloc(sizeof(takmicenje))


void dodaj(takmicenje **p,char *a,char*b,int c){
	takmicenje *tmp,*pos,*res;
	novi(tmp);
	if(tmp==NULL){
		printf("Greska pri alokaciji memorije!\n");
		exit(0);
	}
	int l;
	l=strlen(a)-1;
	a[l]='\0';
	l=strlen(b)-1;
	b[l]='\0';
	
	
	tmp->ekipa=(char*)malloc(strlen(a)+1);
	strcpy(tmp->ekipa,a);
	tmp->igra=(char*)malloc(strlen(b)+1);
	strcpy(tmp->igra,b);
	tmp->broj=c;
	
	tmp->next=NULL;
	
	res=*p;
	if(res==NULL) res=tmp;
	else{
		pos=res;
		while(pos->next!=NULL)
		pos=pos->next;
		pos->next=tmp;
	}
	*p=res;
}


	
takmicenje * form(FILE*f){
	takmicenje*p;
	p=NULL;
	int k;
	char a[50],b[50];
	int c;
	printf("Unesi broj k:\n");
	scanf("%d",&k);
	while(k>0){
		fgets(a,50,f);
		fgets(b,50,f);
		fscanf(f,"%d",&c);
		fgetc(f);
		
		if(c<=5) {
			dodaj(&p,a,b,c);
			k--;
		}
	}
	return p;
}

void ispis(takmicenje*p){
	while(p){
		printf("%s\t%s\t%d\n",p->ekipa,p->igra,p->broj);
		p=p->next;
	}
}

		
void obrnuto(takmicenje*p){
	if(p->next) obrnuto(p->next);
	printf("%s\t%s\t%d\n",p->ekipa,p->igra,p->broj);
	}
int main(int argc,char * argv[]){
	FILE*f;
	f=fopen(argv[1],"r");
	if(f==NULL){
		printf("Greska pri otvaranju datoteke!\n");
		exit(0);
	}
	takmicenje *p;
	p=form(f);
	ispis(p);
	printf("\n\n");
	
	obrnuto(p);
	
	fclose(f);
}


