#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum {CRVENA,CRNA}

typedef struct NAUCNIK{
	char *ime;
	char *tip_rada;
	char *kategorija_rada;
	int boja;
	struct NAUCNIK *levi,*desni,*roditelj; 
}naucnik;

#define novi(x) x=(naucnik*)malloc(sizeof(naucnik))

void lrotacija(naucnik **p){
	naucnik *t,*pom;
	t=*p;
	pom=t->desni;
	t->desni=pom->levi;
	if(pom->levi)pom->levi->roditelj=t;
	pom->roditelj=t->roditelj
	if(t->roditelj)
		if(t==t->roditelj->levi)t->roditelj->levi=pom;
		else t->roditelj->desni=pom;
	pom->levi=t;
	t->roditelj=pom;
	*p=pom;
}

void drotacija(naucnik **p){
	naucnik *t,*pom;
	t=*p;
	pom=t->levi;
	t->levi=pom->desni;
	if(pom->desni)pom->desni->roditelj=t;
	pom->roditelj=t->roditelj
	if(t->roditelj)
		if(t==t->roditelj->levi)t->roditelj->levi=pom;
		else t->roditelj->desni=pom;
	pom->desni=t;
	t->roditelj=pom;
	*p=pom;
}

void bojefix(naucnik **p,naucnik *z){
	naucnik *y;
	while((z->roditelj)&&(z->boja==CRVENA)){
		if(z->roditelj==z->roditelj->roditelj->levi){
			y=z->roditelj->roditelj->desni;
			if((y!=NULL)&&(y->boja==CRVENA)){
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;
				
			}else{
				if(z==z->roditelj->desni){
					z=z->roditelj;
					lrotacija(&z);
					z=z->levi;
					
				}
				z->roditelj->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;
				drotacija(&z);
				if(z->roditelj==NULL) *p=z;
				}
		}
		else{
			y=z->roditelj->roditelj->levi;
			if((y!=NULL)&&(y->boja==CRVENA)){
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;
			}
			else{
				if(z==z->roditelj->levi){
					z=z->roditelj;
					drotacija(&z);
					z=z->desni;}
					z->roditelj->boja=CRNA;
					z=z->roditelj->roditelj;
					z->boja=CRVENA;
					lrotacija(&z);
					if(z->roditelj==NULL) *p=z;
				
			}
		}
		
	}
	(*p)->boja=CRNA;
}

int znacaj(naucnik *z,naucnik *tren){
	int j;
	if((z->tip_rada,tren->tip_rada)==0)
		if((z->tip_rada,"rad")==0){
			if((z->kategorija_rada,tren->kategorija_rada)==0) return 0;
			else if((z->kategorija_rada,"M21")==0) return 1;
			else return 0;
			}
	if(((z->tip_rada,"monografija")==0)&&((tren->tip_rada,"rad")!=0)) return 1;
	if(((z->tip_rada,"monografija")==0)&&((tren->tip_rada,"rad")==0))
	    if((tren->kategorija_rada,"M22")==0) return 1;
	return 0;
}

void dodaj(naucnik **p,naucnik *z){
	naucnik *tren,*pret;
	tren=*p;
	if(tren==NULL) *p=z;
	else{
		while(tren!=NULL){
			pret=tren;
			if(znacaj(z,tren)==0) tren=tren->levi;
			else tren=tren->desni;
		}
		if(znacaj(z,pret)) pret->levi=z;
			else pret->desni=z;
		z->roditelj=pret;
	}
	
	bojefix(p,z);
	
	
}

naucnik *form(){
	naucnik *koren,*z;
	int n,i;
	char s[50];
	koren=NULL;
	scanf("%d",&n);
	for (i = 0; i < n; i++)
	{
		scanf("%s",s);
		novi(z);
		z->ime=(char*)malloc(strlen(s)+1);
		strcpy(z->ime,s);
		scanf("%s",s);
		z->tip_rada=(char*)malloc(strlen(s)+1);
		strcpy(z->tip_rada,s);
		if(strcpy(z->tip_rada,"rad")==0) {
		scanf("%s",s);
		z->kategorija_rada=(char*)malloc(strlen(s)+1);
		strcpy(z->kategorija_rada,s);
		
		}
		z->boja=CRVENA;
		z->levi=z->desni=z->roditelj=NULL;
		dodaj(&koren,z);
	}
	return(koren);
	
	
}

void ispis(naucnik *p){
	if(p!=NULL){
		ispis(p->desni);
		printf("%s",p->ime);
		printf("%s",p-tip_rada);
		if(strcpy(p->tip_rada,"rad")==0)
		printf("%s",p->kategorija_rada);
		if(p->boja==CRVENA) printf("   crvena\n");
		else printf("   CRNA\n");
		ispis(p->levi);
	}
	
}
main(){
	naucnik *p;
	form(&p);
	ispis(p);
	
	
	
	}
