#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Prijava {
	char *naziv_ekipe;
	char *igra;
	int br_igraca;
	struct Prijava *sledeci;
}prijava;

typedef struct Igre {
	char *ime_igre;
	int ukBroj;
	struct Igre *sledeci;
}igre;

#define novi(x) x = (prijava*)malloc(sizeof(prijava));
#define noveIgre(x) x = (igre*)malloc(sizeof(igre));

void dodaj(prijava **p, char *naziv_ekipee, char *igraa, int br_igracaa) {
	prijava *pom, *temp;
	novi(temp);
	if(!temp)
		perror("Greska pri alokaciji memorije\n");
	temp->naziv_ekipe = (char*)malloc(strlen(naziv_ekipee)+1);
	strcpy(temp->naziv_ekipe, naziv_ekipee);
	temp->igra = (char*)malloc(strlen(igraa)+1);
	strcpy(temp->igra, igraa);
	temp->br_igraca = br_igracaa;
	temp->sledeci = NULL;
	if(!(*p)) *p = temp;
	else {
		pom = *p;
		while(pom->sledeci != NULL) pom = pom->sledeci;
		pom->sledeci = temp;
	}
}

void ispis(prijava *p) {
	if(p) {
		while(p) {
			printf("%s\n",p->naziv_ekipe);
			printf("%s\n",p->igra);
			printf("%d\n",p->br_igraca);
			printf("\n______________________________\n");
			p = p->sledeci;
		}
	}else printf("Lista je prazna\n");
}

void ispisIgre(igre *p) {
	if(p) {
		while(p) {
			printf("%s\n",p->ime_igre);
			printf("%d\n",p->ukBroj);
			printf("\n__________________________________\n");
			p = p->sledeci;
		}
	}else printf("Lista je prazna\n");
}

void dodajIgre(igre **p, char *ime, int broj) {
	igre *pom, *temp;
	noveIgre(temp);
	if(!temp)
		perror("Greska pri alokaciji memorije\n");
	temp->ime_igre = (char*)malloc(strlen(ime)+1);
	strcpy(temp->ime_igre, ime);
	temp->ukBroj = broj;
	temp->sledeci = NULL;
	if(!(*p)) *p = temp;
	else {
		pom = *p;
		while(pom->sledeci != NULL) pom = pom->sledeci;
		pom->sledeci = temp;
		//printf("%s\n",temp->ime_igre);
	}
}
/*
void igraUk(prijava *clan,prijava *p, igre **q) {
	prijava *pom, *tren, *brisi,*pom2;
	int br = 0;
	pom = clan;
	pom2 = p;
	tren = p;
	if(pom) {
		while(pom2!=NULL) {
			if(strcmp(tren->igra,pom->igra) == 0)
			{
				
				br++;
				brisi = pom;
				pom = pom->sledeci;
				free(brisi);
			}
			else pom = pom->sledeci;
		}
		dodajIgre(q,tren->igra,br);
	}
}

void igrajse(prijava *p,prijava *lst, igre **q) {
	prijava *pom, *tren;
	tren = p;
	pom = p;
	while(p) {
		igraUk(pom,lst,q);
		tren = tren->sledeci;
		pom = tren;
	}
}
*/


void igraUk(prijava **p, igre **q) {
	prijava *pom, *tren, *brisi,*pom2, *preth = NULL;
	char igraIme[50];
	int br = 0;
	pom = *p;
	printf("Pocetak %s\n",pom->igra);
	while(pom) {
		strcpy(igraIme, pom->igra);
		printf("%s\n",igraIme);
		pom2 = pom;
		printf("%s\n",pom2->naziv_ekipe);
		while(pom2!=NULL) {
			if(strcmp(igraIme,pom2->igra) == 0)
			{
				
				br+=pom2->br_igraca;
				brisi = pom2;
				if(preth == NULL) {
					pom2 = pom2->sledeci;
					pom = pom->sledeci;
					free(brisi);
				}
				else {
					brisi = pom2;
					pom2 = pom2->sledeci;
					preth->sledeci = pom2;
					free(brisi);
					
				}
			}
			else { 
				preth = pom2;
				pom2 = pom2->sledeci;
			}
		}
		dodajIgre(q,igraIme,br);
		br = 0;
	}
}
main() {
	prijava *p = NULL;
	prijava *pom = NULL;
	igre *q = NULL;
	char naziv[50], igraa[50];
	int brojI,n,i = 0;
	scanf("%d",&n);
	getchar();
	while(i<n) {
		gets(naziv);
		gets(igraa);
		scanf("%d",&brojI);
		getchar();
		if(brojI < 5)
		{
			dodaj(&p,naziv, igraa, brojI);
			i++;
		}
	}
	ispis(p);
	pom = p;
	printf("Igre su: \n");
	igraUk(&p,&q);
	printf("Proslo\n");
	ispisIgre(q);
}
