#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct lista{
	char *naziv;
	char *igra;
	int broj;
	struct lista *next;
}lista;

#define novi(x) x=(lista *)malloc(sizeof(lista))

void dodaj(lista **p, char *naziv, char *igra, int broj) {
	lista *temp, *pos, *res;
	res=*p;
	novi(temp);
	temp->naziv=(char *)malloc((strlen(naziv)+1)*sizeof(char));
	strcpy(temp->naziv, naziv);
	temp->igra=(char *)malloc((strlen(igra)+1)*sizeof(char));
	strcpy(temp->igra, igra);
	temp->broj=broj;
	temp->next=NULL;
	if(res==NULL) res=temp;
	else {
		pos=res;
		while(pos->next) pos=pos->next;
		pos->next=temp;
	} *p=res;
}

lista *form(FILE *f){
	lista *p=NULL;
	int k, l;
	char naziv[50];
	char igra[50];
	int broj;
	scanf("%d", &k);
	while(k) {
		fgets(naziv, 50, f);
		l=strlen(naziv)-1;
		naziv[l]='\0';
		fgets(igra, 50, f);
		l=strlen(igra)-1;
		igra[l]='\0';
		fscanf(f,"%d", &broj);
		fgetc(f);
		if(broj<5) {
			dodaj(&p, naziv, igra, broj);
			k--;
		} else break;
	}return p;
}
			
void ispis(lista *p) {
	while(p) {
		printf("%s\t%s\t%d\t", p->naziv, p->igra, p->broj);
		p=p->next;
	}
}

main(int argc, char *argv[]) {
	FILE *f=fopen(argv[1],"r");
	if(!f) {
		printf("greska\n");
	}
	lista *p;
	p=form(f);
	ispis(p);
}
