#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node
{
	char* str;
	int broj;
	struct node *left, *right;
} node;


int broj(char* s)
{
	int br = 0;
	int i;
	int razmak = 1;
	int l = strlen(s);
	for(i = 0; i < l; i++)
	{
		if((s[i] != ' ') && (s[i] != '\t') && (razmak == 1) && (s[i] != '\n'))
		{
			razmak = 0;
			br++;
		}
		if((s[i] == ' ') || (s[i] == '\t') || (s[i] == '\n'))
		{
			razmak = 1;
		}	
	}
	return br;
}	


void add(node** p, char* s)
{
	node *q, *r;
	int len;
	int br;
	br = broj(s);
	len = strlen(s);
	q = (node*)malloc(sizeof(node));
	
	q->left = q->right = NULL;
	q->broj = br;
	q->str = (char*)malloc((len + 1) * sizeof(char));
	strcpy(q->str,s);
	
	if(!(*p))
		*p = q;
	else
	{
		r = *p;
		while(1)
		{
			if(len < strlen(r->str))
			{
				if(r->left)
					r = r->left;
				else
				{
					r->left = q;
					break;
				}
			}
			else if(len > strlen(r->str))
			{
				if(r->right)
					r = r->right;
				else
				{
					r->right = q;
					break;
				}
			}
			else
			{
				if(br < broj(r->str))
				{
					if(r->left)
						r = r->left;
					else
					{
						r->left = q;
						break;
					}
				}
				else
				{
					if(r->right)
						r = r->right;
					else
					{
						r->right = q;
						break;
					}
				}	
			}
		}
	}
	
}

node *form()
{	
	node *p = NULL;
	int n;
	char s[100];
	scanf("%d",&n);
	getchar();
	while(n)
	{
		gets(s);
		add(&p,s);
		n--;
	}
	return p;
}

void print(node *p)
{
	if(p)
	{
		print(p->right);
		printf("%s\t%d\n",p->str,p->broj);
		print(p->left);
	}
}

void nadji(node *p, int g, int k, int *br)
{
	if(p)
	{		
		if((strlen(p->str) >= g)) 
		{
			if(p->broj < k)
				(*br)++;
			nadji(p->left,g,k,br);
			
		}
		nadji(p->right, g, k, br);
	}
}


int main(void)
{
	node *p;
	int br = 0,k,g;
	p = form();
	print(p);
	printf("Unesi br karaktera: \n");
	scanf("%d",&g);
	printf("Unesi br reci: \n");
	scanf("%d",&k);
	nadji(p,g,k,&br);
	printf("\n\nBroj stringova: ");
	printf("%d\n",br);
	
	

}
