#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo
{
	int broj;
	char string[100];
	struct drvo *levi,*desni;
}DRVO;

int brojReci(char *rec)
{
	int br=0,pom=0;
	char c;
	if(rec==NULL) return 0;
	c=rec[0];
	while(c!='\0')
	{
		if((c>='a' && c<='z') || (c>='A' && c<='Z'))
		{
			br++;
			c=rec[++pom];
			while((c!=' ') && (c!='\0') && (c!='\t') && (c!='\n'))
			c=rec[++pom];
		}
		else c=rec[++pom];
	}
	return br;
}

DRVO *Dodaj(DRVO *p,DRVO *temp)
{
	if(p==NULL)
	{
		p=temp;
		p->desni=NULL;
		p->levi=NULL;
	}
	else
	{
		if((strlen(temp->string)>strlen(p->string)) || (strlen(temp->string)==strlen(p->string) && (temp->broj)>=(p->broj)))
		p->desni=Dodaj(p->desni,temp);
		else
		p->levi=Dodaj(p->levi,temp);
	}
	return(p);
}

DRVO *Kreiraj(DRVO *p)
{
	int broj,i,n,c;
	DRVO *temp,*pom;
	
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(DRVO));
		gets(temp->string);
		temp->broj=brojReci(temp->string);
		p=Dodaj(p,temp);
	}
	return(p);
}

void Ispis(DRVO *p)
{
	if(p!= NULL)
	{
		Ispis(p->desni);
		printf("%d %s\n",p->broj,p->string);
		Ispis(p->levi);
	}
	else return;
}

main()
{
	DRVO *p=NULL;
	p=Kreiraj(p);
	Ispis(p);
}
