#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct Naucnici
{
	char IME[50];
	char TIP_RADA[50];
	char KRATEGORIJA_RADA[50];
	struct Naucnici *levi,*desni;
	int balans;
};

int dubina(struct Naucnici *p)
{
	int dl=0,dd=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl<dd) return ++dd;
		else ++dl;	
	}
	else return 0;
}

struct Naucnici *Lrotacija(struct Naucnici *p)
{
	struct Naucnici *pom;
	
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->balans=dubina(p->levi->desni)-dubina(p->levi->levi);
	p->balans=dubina(p->desni)-dubina(p->levi);
	return p;
}

struct Naucnici *Drotacija(struct Naucnici *p)
{
	struct Naucnici *pom;
	
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->levi->balans=dubina(p->levi->desni)-dubina(p->levi->levi);
	p->balans=dubina(p->desni)-dubina(p->levi);
	return p;
}

int Proveri(struct Naucnici *p, struct Naucnici *temp)
{
	if(p->TIP_RADA[0]=='n')
	return 1;
	else
		if (temp->TIP_RADA[0]=='r' && temp->KRATEGORIJA_RADA[2]=='1')
		return 1;
		else
			if(temp->TIP_RADA[0]=='m' && (p->TIP_RADA[0]=='n' || p->TIP_RADA[0]=='m' || (p->TIP_RADA[0]=='r' && KRATEGORIJA_RADA[2]=='2')))
			return 1;
			else
			if(temp->TIP_RADA[0]=='r' && temp->KRATEGORIJA_RADA[2]=='2' && ((p->TIP_RADA[0]=='r' && p->KRATEGORIJA_RADA[2]=='2') || (p->TIP_RADA[0]=='n')))
			return 1;
			return 0;
			
}

int dodaj(struct Naucnici **p2, struct Naucnici *temp)
{
	struct Naucnici *p;
	p=*p2;
	int rez, ink;
	
	rez=0;
	
	if(p==NULL)
	{
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
		p->balans=0;
		rez=1;
	}
	else
	{
		if(Proveri(p,temp)) ink=dodaj(&(p->desni),temp);
		else ink=-dodaj(&(p->levi),temp);
		p->balans=ink;
		
		if(ink != 0 && p->balans != 0)
		{
			if(p->balans<-1)
			{
				if(p->levi->balans<0)
				{
					p=Drotacija(p);
				}
				else
				{
					p->levi=Lrotacija(p->levi);
					p=Drotacija(p);
				}
			}
			else if(p->balans>1)
			{
				if(p->desni->balans>0)
				{
					p=Lrotacija(p);
				}
				else
				{
					p->desni=Drotacija(p->desni);
					p=Lrotacija(p);					
				}
			}
			else rez=1;
		}
	}
	(*p2)=p;
	return rez;
}

void Kreiraj(struct Naucnici **p2)
{
	struct Naucnici *p,*temp;
	int i,n;
	
	p=(*p2);
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(struct Naucnici));
		gets(temp->IME);
		gets(temp->TIP_RADA);
		
		if(strcmp(temp->TIP_RADA,"rad")==0) gets(temp->KRATEGORIJA_RADA);
		else
		strcpy(temp->KRATEGORIJA_RADA,"");
		dodaj(&p,temp);
	}
	(*p2)=p;
}

void ispis(struct Naucnici *p)
{
	if(p != NULL)
	{
		ispis(p->levi);
		printf("%s\t%s\t%s\t(%d)\n",p->IME,p->TIP_RADA,p->KRATEGORIJA_RADA,p->bal);
		ispis(p->desni);
	}
}

void brisi(struct Naucnici *p, struct Naucnici *novo)
{
	if(p!=NULL)
	{
		novo=brisi(p->levi,novo);
		novo=brisi(p->desni,novo);
		
		p->levi=p->desni=NULL;
		
		if(strcmp(p->TIP_RADA,"nema")=0) dodaj(&novo,p);
		else free(p);
	}
	return novo;
}

int brojac(struct Naucnici *p, int *br, int *br2)
{
	if(p!=NULL)
	{
		brojac(p->levi,br,br2);
		brojac(p->desni,br,br2);
		if(strcmp(p->TIP_RADA,"monografija")==0) (*br)++;
		else
		if(p->TIP_RADA[0]=='r' && strcmp(p->KRATEGORIJA_RADA,"M21")==0) (*br)++;
	}
	if((*br)==(*br2)) return 0;
	else if((*br)>(*br2)) return 1;
	else return 2;
}

main()
{
	struct *p=NULL;
	int br1=0,br2=0,br;
	Kreiraj(&p);
	ispis(p);
	printf("\n");
	p=brisi(p,NULL);
	ispis(p);
	
	br=brojac(p,&br1,&br2);
	if(br==0)
	printf("isto\n");
	else if(br==1)
	printf("vise manografije\n");
	else
	printf("vise M21\n");
}
