#include<stdio.h>
#include<stdlib.h>
#include<string.h>
struct drvo {
	char * ime;
	char * tip;
	char * kategorija;
	int balans;
	struct drvo *levi,*desni;
};
#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))


int dubina(struct drvo*p){
	int dl=0,dd=0;
	
	if(p){
		if(p->levi)  dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

void lrotacija(struct drvo **t){
	struct drvo *poml,*pomd;
	poml=*t;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*t=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo**t){
	struct drvo * poml,*pomd;
	pomd=*t;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*t=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}
int proveri(char* rad){
	if (strcmp(rad,"M21")==0) return 3;
	if(strcmp(rad,"monografija")==0) return 2;
	if(strcmp(rad,"M22")==0)   return 1;
	if(strcmp(rad,"nema")==0)  return 0;
}


int dodaj(struct drvo **p,char *a,char *b,char *c){
	int inkrement,rezultat=0;
	struct drvo *t=*p;
	if(t==NULL){
		novi(t);
		if(t==NULL){
			printf("Greska pri alokaciji memorije!\n");
			exit(0);
		}
		
		t->ime=(char*)malloc(strlen(a)+1);
		strcpy(t->ime,a);
		t->tip=(char*)malloc(strlen(b)+1);
		strcpy(t->tip,b);
		
		t->kategorija=(char*)malloc(strlen(c)+1);
		strcpy(t->kategorija,c);
	
			
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else{
		if((proveri(c)>proveri(t->kategorija))) inkrement=dodaj(&(t->desni),a,b,c);
	else if((proveri(c)>proveri(t->tip)))  inkrement=dodaj(&(t->desni),a,b,c);
		else if((strcmp(c,b)==0))
		inkrement=dodaj(&(t->desni),a,b,c);
		else
		inkrement=-dodaj(&(t->levi),a,b,c);
		
		t->balans+=inkrement;
		
		if(inkrement!=0 && t->balans!=0){
			
			if(t->balans<-1){
				if(t->levi->balans<0) drotacija(&t);
				else{lrotacija(&(t->levi)); drotacija(&t);}}
				
			if(t->balans>1){
				if(t->desni->balans>0)  lrotacija(&t);
				else{drotacija(&(t->desni)); lrotacija(&t);}}
				
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

		

struct drvo * form(){
	struct drvo *p;
	p=NULL;
	char a[50],b[50],c[50];
	int n,i;
	printf("Unesite broj radnika:\n");
	scanf("%d",&n);
	
	for(i=0;i<n;i++){
		gets(a);
		gets(b);
		if(strcmp(b,"rad")==0)
		gets(c);
		else 
		gets(c);
		
		
			
		dodaj(&p,a,b,c);
	}

	return p;
}


void ispis(struct drvo *p){
	if(p){
		if(p->desni) ispis(p->desni);
		printf("%s\t%s\t%s\t%d\n",p->ime,p->tip,p->kategorija,p->balans);
		if(p->levi) ispis(p->levi);
	}
}

int main(){
	struct drvo *p,*q=NULL;
	p=form();
	ispis(p);
	printf("\n\n");
}



