#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum{CRVENA, CRNA};

typedef struct stablo {
	int boja;
	char *ime;
	char *tip;
	char *kategorija;
	struct stablo *levi, *desni, *roditelj;
} stablo;

#define novi(x) x=(stablo *)malloc(sizeof(stablo));

void lrot(stablo **p){
	stablo *x, *y;
	x=*p;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
	if(x==x->roditelj->levi) x->roditelj->levi=y;
	else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*p=y;
}

void drot(stablo **p) {
	stablo *x, *y;
	y=*p;
	x=y->levi;
	y->levi=x->desni;
	if(x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj)
	if(y==y->roditelj->levi) y->roditelj->levi=x;
	else y->roditelj->desni=x;
	x->desni=y;
	y->roditelj=x;
	*p=x;
}

void bojefix(stablo **p, stablo *z) {
	stablo *y, *t;
	while((z->roditelj) && (z->roditelj->boja==CRVENA)) {
		if(z->roditelj==z->roditelj->roditelj->levi) {
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja==CRVENA)) {
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else {
				if(z==z->roditelj->desni) {
					z=z->roditelj;
					lrot(&z);
					if(z->roditelj==NULL) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drot(&t);
				if(t->roditelj==NULL) *p=t;
			}
		}else {
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja==CRVENA)) {
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else {
				if(z==z->roditelj->levi) {
					z=z->roditelj;
					drot(&z);
					if(z->roditelj==NULL) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrot(&t);
				if(t->roditelj==NULL) *p=t;
			}
		}
	} (*p)->boja=CRNA;
}

int poredi(char *s) {
	if(strcmp(s,"rad")==0) return 1;
	else return 0;
}

stablo *form() {
	stablo *p=NULL;
	int i, n, l;
	char ime[50];
	char tip[50];
	char kategorija[50];
	scanf("%d", &n);
	for(i=0;i<n;i++) {
		gets(ime);
		l=strlen(ime)-1;
		ime[l]='\0';
		gets(tip);
		l=strlen(tip)-1;
		tip[l]='\0';
		gets(kategorija);
		kategorija[l]='\0';
	}
}	
void ispis(stablo *p) {
	if(p) {
		ispis(p->desni);
		printf("%s\t%s\t%s\t", p->ime, p->tip, p->kategorija);
		if(p->boja==CRVENA) printf("crvena");
		else printf("crna");
		ispis(p->levi); 
}
}


main() {
	stablo *p;
	p=form();
	ispis(p);
}
